﻿
local AssignSoldier = foundation.createMod();

_assignSoldierPrefix = "ASSIGN_SOLDIER_V3"
_StoneGateSetPrefix = "STONE_GATE_V7"
_CommonWindowPrefix = "CUSTOM_WINDOW_V2"
--_CommonDoorPrefix = "CUSTOM_DOOR_V2"

AssignSoldier:log("Hello World: AssignSoldier")
--AssignSoldier:logWarning("This is a warning!")
--AssignSoldier:logError("This is an error!")
--AssignSoldier:msgBox("AssignSoldier: Hello there")

if (foundation.getGameVersion == nil) or (version.cmp(foundation.getGameVersion(), "1.6") < 0) then
    AssignSoldier:msgBox("AssignSoldier: game version anterior to 1.6")
    return
end
AssignSoldier:msgBox("AssignSoldier: game version" .. foundation.getGameVersion())

-- Temporary: global function from Stone Gate Set
-- Register the stone gate set monument
function configureMaterialSet(_color, _material, _colorWall, _colorCrenellation, _colorBasement, _colorFloorGround, _defaultMaterial)
    function configureWindowRoofMaterial(_core)
        if _defaultMaterial then
            return CommonWindowPrefix .. "_" .. _core .. "_" .. _color .. "_" .. _material .. "_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _color .. "_" .. _material .. "_MATERIAL"
        end
    end
    function configureWindowWallMaterial(_core)
        if _defaultMaterial then
            return CommonWindowPrefix .. "_" .. _core .. "_" .. _colorWall .. "_WALL_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorWall .. "_WALL_MATERIAL"
        end
    end
    function configureSimpleRoofMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _color .. "_" .. _material .. "_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _color .. "_" .. _material .. "_MATERIAL"
        end
    end
    function configurePointedRoofMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _color .. "_POINTED_" .. _material .. "_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _color .. "_" .. _material .. "_MATERIAL"
        end
    end
    function configureRoofOverMachicolationsMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. "_" .. _color .. "_" .. _material .. "_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _color .. "_" .. _material .. "_MATERIAL"
        end
    end
    function configureWallMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorWall .. "_WALL_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorWall .. "_WALL_MATERIAL"
        end
    end
    function configureCrenellationMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorCrenellation .. "_CRENELLATION_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorCrenellation .. "_CRENELLATION_MATERIAL"
        end
    end
    function configureBasementMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorBasement .. "_BASEMENT_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorBasement .. "_BASEMENT_MATERIAL"
        end
    end
    function configureFloorGroundMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorFloorGround .. "_FLOOR_GROUND_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorFloorGround .. "_FLOOR_GROUND_MATERIAL"
        end
    end
    
    return  {
                SetName = StoneGateSetPrefix .. "_" .. _color .. "_" .. _material .. "_" .. _colorWall,
                MaterialList = {
                    -- from Windows Decoration mod
                    configureWindowRoofMaterial("STONE_WINDOW"),
-- currently not used                    configureWindowRoofMaterial("WOODEN_DOOR"),
                    configureWindowRoofMaterial("WOODEN_WINDOW"),
                    configureWindowRoofMaterial("WOODEN_ENTRANCE"),
                    configureWindowWallMaterial("STONE_DECORATION"),
                    configureWindowWallMaterial("STONE_BUTTRESS"),
                    -- simple roofs
                    configureSimpleRoofMaterial("MAIN"),
                    configureSimpleRoofMaterial("KEEP"),
                    configureSimpleRoofMaterial("SST"),
                    configureSimpleRoofMaterial("SGATE"),
                    configureSimpleRoofMaterial("A45"),
                    configureSimpleRoofMaterial("OTOWER"),
                    configureSimpleRoofMaterial("CIRCULAR"),
                    configureSimpleRoofMaterial("SCT"),
                    -- pointed roofs
                    configurePointedRoofMaterial("MAIN"),
                    configurePointedRoofMaterial("KEEP"),
                    configurePointedRoofMaterial("SST"),
                    configurePointedRoofMaterial("OTOWER"),
                    configurePointedRoofMaterial("CIRCULAR"),
                    configurePointedRoofMaterial("SCT"),
                    configurePointedRoofMaterial("SGATE"),
                    configurePointedRoofMaterial("A45"),
                    -- roofs over machicolations
                    configureRoofOverMachicolationsMaterial("MAIN"),
                    configureRoofOverMachicolationsMaterial("KEEP"),
                    configureRoofOverMachicolationsMaterial("SST"),
                    configureRoofOverMachicolationsMaterial("SGATE"),
                    configureRoofOverMachicolationsMaterial("SGATE2"),
                    configureRoofOverMachicolationsMaterial("A45"),
                    configureRoofOverMachicolationsMaterial("OTOWER"),
                    configureRoofOverMachicolationsMaterial("CIRCULAR"),
                    configureRoofOverMachicolationsMaterial("SCT"),
                    -- wall
                    configureWallMaterial("OVER_HANGING"),
                    configureWallMaterial("A45"),
                    configureWallMaterial("CIRCULAR"),
                    configureWallMaterial("KEEP"),
                    configureWallMaterial("LARGE_GATE"),
                    configureWallMaterial("MAIN"),
                    configureWallMaterial("OTOWER"),
                    configureWallMaterial("SCT"),
                    configureWallMaterial("SGATE"),
                    configureWallMaterial("SST"),
                    configureWallMaterial("RAMPART_SST"), -- wall parts from the stairs
                    configureWallMaterial("BRIDGE_SST"),
                    configureWallMaterial("DECORATIONS_PINION"),
                    configureWallMaterial("DRAWBRIDGE_A"),
                    configureWallMaterial("MACHICOLATION_KEEP"),
                    configureWallMaterial("MACHICOLATION_MAIN"),
                    configureWallMaterial("MACHICOLATION_SST"),
                    configureWallMaterial("MACHICOLATION_SGATE"),
                    configureWallMaterial("MACHICOLATION_A45"),
                    configureWallMaterial("MACHICOLATION_OTOWER"),
                    configureWallMaterial("MACHICOLATION_CIRCULAR"),
                    configureWallMaterial("MACHICOLATION_SCT"),
                    configureWallMaterial("POINTED_ROOFS_PINION"),
                    -- crenellation
                    configureCrenellationMaterial("RAMPART_A45"),
                    configureCrenellationMaterial("RAMPART_CIRCULAR"),
                    configureCrenellationMaterial("RAMPART_KEEP"),
                    configureCrenellationMaterial("RAMPART_MAIN"),
                    configureCrenellationMaterial("RAMPART_OTOWER"),
                    configureCrenellationMaterial("RAMPART_SCT"),
                    configureCrenellationMaterial("SGATE"),
                    configureCrenellationMaterial("RAMPART_SST"),
                    configureCrenellationMaterial("HOARDING_A45"),
                    configureCrenellationMaterial("HOARDING_CIRCULAR"),
                    configureCrenellationMaterial("HOARDING_OTOWER"),
                    configureCrenellationMaterial("HOARDING_S3"),
                    configureCrenellationMaterial("HOARDING_EXTENSION_S3"),
                    configureCrenellationMaterial("HOARDING_S2"),
                    configureCrenellationMaterial("HOARDING_EXTENSION_S2"),
                    configureCrenellationMaterial("HOARDING_S1"),
                    configureCrenellationMaterial("HOARDING_SGATE"),
                    configureCrenellationMaterial("HOARDING_SGATE2"),
                    configureCrenellationMaterial("MACHICOLATION_KEEP"),
                    configureCrenellationMaterial("MACHICOLATION_CRENATION"),
                    configureCrenellationMaterial("MACHICOLATION_MAIN"),
                    configureCrenellationMaterial("MACHICOLATION_SST"),
                    configureCrenellationMaterial("MACHICOLATION_SGATE"),
                    configureCrenellationMaterial("MACHICOLATION_SGATE2"),
                    configureCrenellationMaterial("MACHICOLATION_A45"),
                    configureCrenellationMaterial("MACHICOLATION_OTOWER"),
                    configureCrenellationMaterial("MACHICOLATION_CIRCULAR"),
                    configureCrenellationMaterial("MACHICOLATION_SCT"),
                    -- basement
                    configureBasementMaterial("MAIN"),
                    configureBasementMaterial("KEEP"),
                    configureBasementMaterial("OTOWER"),
                    configureBasementMaterial("CIRCULAR"),
                    configureBasementMaterial("SST"),
                    -- floor ground
                    configureFloorGroundMaterial("SST"),
                    configureFloorGroundMaterial("RAMPART_SST"), -- ground parts from the stairs
                    configureFloorGroundMaterial("BRIDGE_SST"),
                    configureFloorGroundMaterial("MACHICOLATION_SST"),
                    configureFloorGroundMaterial("KEEP"),
                    configureFloorGroundMaterial("MACHICOLATION_KEEP"),
                    configureFloorGroundMaterial("MAIN"),
                    configureFloorGroundMaterial("MACHICOLATION_MAIN"),
                    configureFloorGroundMaterial("A45"),
                    configureFloorGroundMaterial("MACHICOLATION_A45"),
                    configureFloorGroundMaterial("CIRCULAR"),
                    configureFloorGroundMaterial("MACHICOLATION_CIRCULAR"),
                    configureFloorGroundMaterial("OTOWER"),
                    configureFloorGroundMaterial("MACHICOLATION_OTOWER"),
                    configureFloorGroundMaterial("SCT"),
                    configureFloorGroundMaterial("MACHICOLATION_SCT"),
                    configureFloorGroundMaterial("SGATE"),
                    configureFloorGroundMaterial("MACHICOLATION_SGATE"),
                    configureFloorGroundMaterial("MACHICOLATION_SGATE2"),
                    configureFloorGroundMaterial("LARGE_GATE"),
               }
    }
end

function checkVersion(_name, _id, _minimalVersion)
    if (foundation.getModVersion == nil) then
        AssignSoldier:msgBox("AssignSoldier: Unknown mod version")
        return false
    end
    if not foundation.isModEnabled(_id) then
        AssignSoldier:msgBox("AssignSoldier: " .. _name .. " disabled")
        return false
    end
    if not foundation.isModLoaded(_id) then
        AssignSoldier:msgBox("AssignSoldier: Up the position of " .. _name .. " in the mod list of your game")
        return false
    end
    local _myVersion = foundation.getModVersion(_id)
    AssignSoldier:msgBox("AssignSoldier: " .. _name .. " Current version : " .. _myVersion)
    if version.cmp(_myVersion, _minimalVersion) < 0 then
        AssignSoldier:msgBox("AssignSoldier: Please, load the last version of " .. _name)
        return false
    end
    return true
end

-- check all the mandatory dependencies
_flagSg7 = checkVersion("Stone Gate Set V7", "ad4b77eb-f903-4ade-89df-043293e696ec", "7.3.20")
_flagSecurity = checkVersion("Security", "99ee3b3b-f103-41f0-a725-bc466a2fc6de", "1.0.8")
if not _flagSg7 then
    return 
end

AssignSoldier:dofile("scripts/monument.lua")
