local AssignSoldier = ...

-- Register all stone gate set building parts and their properties
AssignSoldier:dofile("scripts/compPathAccess.lua")
AssignSoldier:dofile("scripts/compPathAEnd.lua")
AssignSoldier:dofile("scripts/basicWorkplace.lua")
AssignSoldier:dofile("scripts/behavior_tree.lua")

-- Register the stone gate set monument
if _flagSg7 then
-- Adds the specific materials od Soldier Assignment to the already existing list of themes
    function configureMaterialSet2(_color, _material, _colorWall, _colorCrenellation, _colorBasement, _defaultMaterial)
        function configureSimpleRoofAccessMaterial(_core)
            if _defaultMaterial then
                return _assignSoldierPrefix .. "_" .. _core .. "_" .. _color .. "_" .. _material .. "_MATERIAL"
            else
                return _CommonWindowPrefix .. "_DECORATION_" .. _color .. "_" .. _material .. "_MATERIAL"
            end
        end
        function configureWallAccessMaterial(_core)
            if _defaultMaterial then
                return _assignSoldierPrefix .. "_" .. _core .. "_" .. _colorWall .. "_WALL_MATERIAL"
            else
                return _CommonWindowPrefix .. "_DECORATION_" .. _colorWall .. "_WALL_MATERIAL"
            end
        end

        AssignSoldier:log("init configureMaterialSet")
        local materialSet = configureMaterialSet(_color, _material, _colorWall, _colorCrenellation, _colorBasement, _defaultMaterial)
        AssignSoldier:log("init configureMaterialSet")
        table.insert(materialSet.MaterialList, configureSimpleRoofAccessMaterial("OTOWER"))
        table.insert(materialSet.MaterialList, configureWallAccessMaterial("OTOWER"))
        AssignSoldier:log("end configureMaterialSet" .. tostring(materialSet))
        return materialSet
    end


    AssignSoldier:override({
        Id = _StoneGateSetPrefix .. "_MONUMENT",
        BuildingPartSetList = {
                Action = "APPEND",
		{
			Name = _StoneGateSetPrefix .. "_ENTRANCE_PARTSETLIST_NAME",
                	BuildingPartList = {
                            _assignSoldierPrefix .. "_KEEP_TRAP_ACCESS_PART",
                            _assignSoldierPrefix .. "_SMALL_GATE_ACCESS_R_PART",
                            _assignSoldierPrefix .. "_SMALL_GATE_ACCESS_L_PART",
                            _assignSoldierPrefix .. "_OCTOGONAL_TOWER_ACCESS_PART",
                        }
                }
        },
        MaterialSetList = {
            configureMaterialSet2("RED", "ROOF", "MANOR2", "BLUE", "MANOR2", true), -- default material
            configureMaterialSet2("BLUE", "ROOF", "MANOR2", "BLUE", "MANOR2", false),
            configureMaterialSet2("BROWN", "ROOF", "MANOR2", "BLUE", "MANOR2", false),
            configureMaterialSet2("GREY", "ROOF", "MANOR2", "BLUE", "MANOR2", false),
            configureMaterialSet2("GREY2", "ROOF", "MANOR2", "BLUE", "MANOR2", false),
            configureMaterialSet2("RED", "WROOF", "MANOR2", "BLUE", "MANOR2", false),
            configureMaterialSet2("BLUE", "WROOF", "MANOR2", "BLUE", "MANOR2", false),
            configureMaterialSet2("BROWN", "WROOF", "MANOR2", "BLUE", "MANOR2", false),
            configureMaterialSet2("YELLOW", "WROOF", "MANOR2", "BLUE", "MANOR2", false),
            configureMaterialSet2("GREEN", "WROOF", "MANOR2", "BLUE", "MANOR2", false ),
            configureMaterialSet2("MANOR", "WROOF", "MANOR2", "BLUE", "MANOR2", false),
            configureMaterialSet2("MANOR2", "WROOF", "MANOR2", "BLUE", "MANOR2", false),
            configureMaterialSet2("BROWN_MONASTERY", "ROOF", "BROWN_MONASTERY", "BROWN_MONASTERY", "BROWN_MONASTERY", false),
            configureMaterialSet2("BLUE_MONASTERY", "ROOF", "BLUE_MONASTERY", "BLUE_MONASTERY", "BLUE_MONASTERY", false),
            configureMaterialSet2("PURPLE_MONASTERY", "ROOF", "PURPLE_MONASTERY", "PURPLE_MONASTERY", "PURPLE_MONASTERY", false),
            configureMaterialSet2("MANOR", "WROOF", "RED_STONE", "RED_STONE", "RED_STONE", false),
            configureMaterialSet2("RED", "WROOF", "GIANT_GATE", "GIANT_GATE", "GIANT_GATE", false),
            configureMaterialSet2("STRAW", "ROOF", "WHITE_CHALK", "WHITE_CHALK", "MANOR2", false),
            configureMaterialSet2("BROWN_MONASTERY", "ROOF", "WHITE_CHALK", "WHITE_CHALK", "MANOR2", false),
            configureMaterialSet2("RED", "ROOF", "SAND_STONE", "SAND_STONE", "SAND_STONE", false),
            configureMaterialSet2("BROWN", "ROOF", "SAND_STONE", "SAND_STONE", "SAND_STONE", false),
            configureMaterialSet2("STRAW", "ROOF", "WOOD", "WHITE_CHALK", "MANOR2", false),
        }
    })
end
